/*
 * $Header: /cvsroot/xwinx/xwinx/xwx.h,v 1.17 2001/11/16 07:22:12 snaund Exp $
 * xwx.h - xwinx core header file 
 * Copyright (C) 2001 Kim Saunders, Sanjay Rao
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* product name, version and year for output to user */
#define XWX_NAME "XWinX"
#define XWX_VERS "0.03"
#define XWX_YEAR 2001
#define XWX_COPY "Kim Saunders, Sanjay Rao"

struct params {
	char *invname;	/* name xwinx was invoked under (argv[0]) */
	char *display;
	char *cookie_dat;	/* MIT-MAGIC-COOKIE-1 to send to the server */
	int cookie_len;
	int depth;
	int swapcaps;
	int httpport;
	char *httpauth;
	int nodisplay; /* boolean */
};

struct imginfo {
	int x11depth;
	int x11quantum;
	int w32depth;
	int Bpp, Bpl; /* these are X11 values */
	int badcolor;
	unsigned int width;
	unsigned int height;
	char *ximagebuffer;
};

struct win32info {
	HDC dev; /* root hdc */
	HDC mdev; /* compatible hdc to root */
	BITMAPINFO bmi;
	HBITMAP hbitmap; /* bitmap compatible with root's bitmap */
	HBITMAP obitmap; /* original bitmap for mdev */
};

struct x11info {
	Display *display;
	Window window;
	Colormap colormap;
	Visual *visual;
	int screen;
	GC context;
	XGCValues vls;
	XImage *image;
	XSetWindowAttributes attributes;
	unsigned char *colorindex;
	int pmx, pmy;			/* previous mouse coords */
	XModifierKeymap *modifiers;	/* modifer keymap for display */
};

struct xmission {
	int *ldiff;
	char *cdiff;
	int *lefts;
	int *rights;
	char *oneline;
};

struct xinput {
	struct x11info *x11info;
	struct params *params;

	pthread_mutex_t inputlock;
	HANDLE deadlock;

	int exp_b; /* boolean, => expose event to process 
		     be sure to lock with inputlock
		    */
	int exp_x,exp_y,exp_w,exp_h;

	int unfocus; /* boolean for now, current focus status */
};

#define freeup(a) { if (a) { free(a); a=NULL; } }

int ispaused_xwinx(void); 
int pause_xwinx(void) ;
int unpause_xwinx(void);
void colorcorrect(char *oneline, int xpix);
